/** \file
	gentestdata,
	test data generator, to create simple testpattern for usage with eatr.c
*/
#include "local.h"


static float sinus(int j) {
	return ( (float)
		sin(
			(double)(3.1415/(50*60)) * j/*SAMPLEFREQUENCY*/
			)
		);
}
static float snare(int j) {
	return(
		(float) (j%(SAMPLEFREQUENCY/(int)(1.5*4))) /
		(SAMPLEFREQUENCY/(int)(1.5*4))
		);
}

int main() {
	int i, j, last, ret;
	unsigned int skip;
	FILE * REJ;
	FILE * EEG;
	struct s_cntconvhead header;
	float wave[300000];
	float * cwave;
	float tmp;
	short int art[300000];
	srand((unsigned int) time(NULL));
	REJ=fopen("testdata.rej", "w");
	if (NULL==REJ) {
		fprintf(stderr, "could not open file \"testdata.rej\"\n");
		exit(1);
	}
	EEG=fopen("testdata.eeg", "wb");
	if (NULL==EEG) {
		fprintf(stderr, "could not open file \"testdata.eeg\"\n");
		exit(1);
	}
		fprintf(EEG, "#EEGbu"); /* header */
	header.channelcount=MAX_MAPPED_CHANNELS;
	header.samplecount=300000;
	ret=(int)fwrite(&header, sizeof(header), (size_t) (1), EEG);
	if (ret != (int) (1)) {
		fprintf(stderr, "could not write pcbuf to stdout-stream, only %i of %i written: %s\n", ret, (1),strerror(errno));
		exit(ERRSTREAM);
	}

	skip=0; last=1;
	for (i=0; i<300000; i++) { /* count of samples */
		if (-1 == last) {
			wave[i]=sinus(i);
			art[i]=0;
			/* printf("i: %i, w:%f, a:%i s\n", i, wave[i], art[i]); */
		} else {
			wave[i]=snare(i);
			art[i]=1;
			/* printf("i: %i, w:%f, a:%i z\n", i, wave[i], art[i]); */
		}
		/* getchar(); */
		if (0>=skip) {
			skip=mrandomize(30)*10;
			last= last * (-1);
		} else skip--;
		/* fprintf(REJ, "%i %i\n", i, art[i]);
		fprintf(EEG, "%i %f\n", i, wave[i]); */
	}
	cwave=NULL;
	cwave=malloc(sizeof(float)*300000*MAX_MAPPED_CHANNELS);
	if (NULL==cwave) {
		fprintf(stderr, "could not alloc mem for buf, %s\n", strerror(errno));
		exit(ERRMEM);
	}
	for (i=0; i<300000; i++) {
		for (j=0; j<MAX_MAPPED_CHANNELS; j++) { /* simulate MAX_MAPPED_CHANNELS channels */
			tmp=wave[i];
			cwave[i*MAX_MAPPED_CHANNELS+j]=tmp;

		}
	}
	ret=(int)fwrite(cwave, sizeof(float), (size_t) (300000*MAX_MAPPED_CHANNELS), EEG);
	if (ret != (int) (300000*MAX_MAPPED_CHANNELS)) {
		fprintf(stderr, "could not write pcbuf to stdout-stream, only %i of %i written: %s\n", ret, (300000*MAX_MAPPED_CHANNELS),strerror(errno));
		exit(ERRSTREAM);
	}
	last=0;
	for (i=0; i<300000; i++) {
		if ((0==last) && (1==art[i])) {
			last=1;
			fprintf(REJ, "%0.3f-", (float)i/SAMPLEFREQUENCY);
		} else if ((1==last) && (0==art[i])) {
			last=0;
			fprintf(REJ, "%0.3f\n", (float) i/SAMPLEFREQUENCY);
		}
	}
	if ((1==last) && (1==art[i-1])) { /* abs(begins-ends)==1 or in other words "1423-" */
		fprintf(REJ, "%0.3f\n", (float) i/SAMPLEFREQUENCY);
	}
	(void) fclose(REJ);
	(void) fclose(EEG);
	return(0);
}

