/** \file
	eeg2dat
   converts decompressed EEG-Data to dat-Files to plot with gnuplot and Co.
   (c) 2004 by Andreas Romeyke
*/

#include "local.h"
/** converts decompressed EEG-data to gnuplot-compatible dat-Files */
int main(int argc, char * argv[]) {
	unsigned int sample;
	unsigned int samplecount;
	unsigned short int channelcount;
	unsigned short int channel;
	float * tmpinput;
	tmpinput=NULL;
	if (2!=argc) {
		fprintf(stderr,"EEG 2 DAT -- E2D\n");
		fprintf(stderr,"(c) by Andreas Romeyke, distributed under terms of GPL\n");
		fprintf(stderr,"  reads decompressed EEG-stream from STDIN, and writes a\n");
		fprintf(stderr,"  a gnuplot-compatible dat-stream to STDOUT\n");
		fprintf(stderr,"call\n %s <eeg-filename>\n", argv[0]);
		exit(ERRARG);
	}
	/* create or load neural network */
	/* load and parse EEG-data from input */
	parse_eeg(argv[1], &channelcount,  &samplecount, &tmpinput);
	for (sample=0; sample< samplecount; sample++) {
		fprintf(stdout, "%u", sample);
		for (channel=0; channel<channelcount; channel++) {
			fprintf(stdout, " %f", tmpinput[sample*channelcount+channel]);
		}
		fprintf(stdout, "\n");
	}
	(void) fflush(stdout);
	(void) fflush(stderr);
	return(0);
}

